#include "fkctrl.h"

static FKCtrlClassDesc FKCtrlDesc;
ClassDesc2* GetFKCtrlDesc() { return &FKCtrlDesc; }
static FKCtrlClassAccessor FKCtrlAccessor;

enum { 
	IKFKPrefRot_params,
};
enum {
	pb_prefRotX,
	pb_prefRotY,
	pb_prefRotZ,
};

static ParamBlockDesc2 IKFKPrefRot_param_blk ( IKFKPrefRot_params, _T("params"),  0, &FKCtrlDesc, 
	P_AUTO_CONSTRUCT, LOCALPBLOCK_REF, 
	// params
	pb_prefRotX, 		_T("PrefRotX"), 		TYPE_ANGLE, 	P_ANIMATABLE, 	IDS_PREFROTX, 
		p_default, 		0.0f,
		end,
	pb_prefRotY, 		_T("PrefRotY"), 		TYPE_ANGLE, 	P_ANIMATABLE, 	IDS_PREFROTY, 
		p_default, 		0.0f,
		end,
	pb_prefRotZ, 		_T("PrefRotZ"), 		TYPE_ANGLE, 	P_ANIMATABLE, 	IDS_PREFROTZ, 
		p_default, 		0.0f,
		end,
	pb_matchMainPreferred,	_T("MatchMainPrefRotation"),	TYPE_BOOL,	P_NO_REF,	IDS_MATCHMAINPREFERRED,
		p_accessor,		&FKCtrlAccessor,
		end,
	pb_matchSecPreferred,	_T("MatchSecPrefRotation"),	TYPE_BOOL,	P_NO_REF,	IDS_MATCHSECPREFERRED,
		p_accessor,		&FKCtrlAccessor,
		end,
	pb_matchScaleMult,	_T("MatchScaleMult"),	TYPE_BOOL,	P_NO_REF,	IDS_MATCHSCALEMULT,
		p_accessor,		&FKCtrlAccessor,
		end,
	pb_parentSpace, 	_T("ParentSpace"),		TYPE_INT,		P_NO_REF,				IDS_PARENTSPACE, 
		p_accessor,		&FKCtrlAccessor,
		end,
	pb_prefTreshold,	_T("PrefTreshold"), 		TYPE_ANGLE, 	P_NO_REF, 	IDS_PREFTRESHOLD, 
		p_accessor,		&FKCtrlAccessor,
		end,
	pb_displayGoal,	_T("DisplayGoal"),	TYPE_INT,	P_NO_REF,	IDS_DISPLAYGOAL,
		p_accessor,		&FKCtrlAccessor,
		end,
	pb_displayTarget,	_T("DisplayTarget"),	TYPE_INT,	P_NO_REF,	IDS_DISPLAYTARGET,
		p_accessor,		&FKCtrlAccessor,
		end,
	pb_displayIKFK,	_T("DisplayIKFK"),	TYPE_BOOL,	P_NO_REF,	IDS_DISPLAYIKFK,
		p_accessor,		&FKCtrlAccessor,
		end,
	pb_showAllKeys,	_T("ShowAllNodesKeys"),	TYPE_BOOL,	P_NO_REF,	IDS_SHOWALLKEYS,
		p_accessor,		&FKCtrlAccessor,
		end,
	pb_matchIKFK,	_T("MatchIKFK"),	TYPE_BOOL,	P_NO_REF,	IDS_MATCHIKFK,
		p_accessor,		&FKCtrlAccessor,
		end,
	pb_matchTargetSwivel,	_T("MatchTargetSwivel"),	TYPE_BOOL,	P_NO_REF,	IDS_MATCHTARGETSWIVEL,
		p_accessor,		&FKCtrlAccessor,
		end,
	end
	);

//interface desc to publish functions
static FPInterfaceDesc FKCtrl_mixininterface(IKFKSOLVER_INTERFACE, 
   _T("refs"), 0, &FKCtrlDesc, 0, 
   IKFKSolverInterface::fnMatch, _T("Match"), 0, TYPE_VOID, 0, 0, 
   IKFKSolverInterface::fnSetFK, _T("SetFK"), 0, TYPE_VOID, 0, 0,
   IKFKSolverInterface::fnSetIK, _T("SetIK"), 0, TYPE_VOID, 0, 0,
   IKFKSolverInterface::fnGetMainFKNode, _T("GetMainFKNode"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnGetSecFKNode, _T("GetSecFKNode"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnGetLastFKNode, _T("GetLastFKNode"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnGetGoal, _T("GetGoal"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnGetTarget, _T("GetTarget"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnGetGoalParent, _T("GetGoalParent"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnSetTarget, _T("SetTarget"), 0, TYPE_VOID, 0, 1, 
     _T("Target Node"), 0, TYPE_INODE, 
   IKFKSolverInterface::fnSetGoalParent, _T("SetGoalParent"), 0, TYPE_VOID, 0, 1, 
     _T("Goal Parent Node"), 0, TYPE_INODE, 
   end 
); 

FPInterfaceDesc* FKCtrl::GetDesc() 
{ 
   return &FKCtrl_mixininterface; 
}



void FKCtrlClassAccessor::Set (PB2Value &v, ReferenceMaker *owner, ParamID id, int tabIndex, TimeValue t)
{
	FKCtrl* theFKCtrl=((FKCtrl*)owner);
	if (theFKCtrl && theFKCtrl->solver && theFKCtrl->solver->pblock)
	{
		if (id==pb_prefTreshold)
			theFKCtrl->solver->pblock->SetValue(id,t,v.f);
		else
			theFKCtrl->solver->pblock->SetValue(id,t,v.i);
	}
}
void FKCtrlClassAccessor::Get (PB2Value &v, ReferenceMaker *owner, ParamID id, int tabIndex, TimeValue t, Interval &valid)
{
	FKCtrl* theFKCtrl=((FKCtrl*)owner);
	if (theFKCtrl && theFKCtrl->solver && theFKCtrl->solver->pblock)
	{
		if (id==pb_prefTreshold)
			theFKCtrl->solver->pblock->GetValue(id,t,v.f,valid);
		else
			theFKCtrl->solver->pblock->GetValue(id,t,v.i,valid);
	}
}


FKCtrl::FKCtrl(BOOL loading)
{
	prefPblock=NULL;
	FK=NULL;
	pblock=NULL;
	solver=NULL;
	value=Matrix3(1);
	ivalid=FOREVER;
	mustdelete=FALSE;
	sendingMessage=FALSE;
	allKeysActive=FALSE;
	if (!loading)
		FKCtrlDesc.MakeAutoParamBlocks(this);
}
FKCtrl::FKCtrl(IKFKSolver *theSolver)
{
	prefPblock=NULL;
	FK=NULL;
	pblock=NULL;
	solver=NULL;
	value=Matrix3(1);
	ivalid=FOREVER;
	mustdelete=FALSE;
	sendingMessage=FALSE;
	allKeysActive=FALSE;
	FKCtrlDesc.MakeAutoParamBlocks(this);

	if (prefPblock)
	{
#if IS_SUPMAX2012
		prefPblock->SetControllerByIndex(pb_prefRotX,0,NewDefaultFloatController());
		prefPblock->SetControllerByIndex(pb_prefRotY,0,NewDefaultFloatController());
		prefPblock->SetControllerByIndex(pb_prefRotZ,0,NewDefaultFloatController());
#else
		prefPblock->SetController(pb_prefRotX,0,NewDefaultFloatController());
		prefPblock->SetController(pb_prefRotY,0,NewDefaultFloatController());
		prefPblock->SetController(pb_prefRotZ,0,NewDefaultFloatController());
#endif
	}

	ReplaceReference(LOCALCTRL_REF,NewDefaultMatrix3Controller());
	if (theSolver)
		ReplaceReference(SOLVERPBLOCK_REF,theSolver->pblock);
	ReplaceReference(SOLVER_REF,theSolver);
}
FKCtrl::~FKCtrl()
{
	DeleteAllRefs();
}
//Animatable Methods

Animatable* FKCtrl::SubAnim(int i)
{
	switch(i)
	{
	case LOCALPBLOCK_REF:
		return prefPblock;
		break;
	case LOCALCTRL_REF:
		return FK;
		break;
	case SOLVERPBLOCK_REF:
		return solver;
		break;
	}
	return NULL;
}
TSTR FKCtrl::SubAnimName(int i)
{
	switch(i)
	{
	case LOCALPBLOCK_REF:
		return GetString(IDS_PREFPARAMS);
		break;
	case LOCALCTRL_REF:
		return GetString(IDS_FK);
		break;
	case SOLVERPBLOCK_REF:
		return GetString(IDS_PARAMS);
		break;
	}
	return _T("");
}
BOOL FKCtrl::AssignController(Animatable *control,int subAnim)
{
	if (subAnim==LOCALCTRL_REF)
	{
		ReplaceReference(subAnim,(Control*)control);
		return TRUE;
	}
	else
		return FALSE;
}
//to display controller params on the motion panel,
void FKCtrl::BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev )
{
	if (solver)
		solver->BeginEditParams(ip,flags,NULL);
	if (FK)
		FK->BeginEditParams(ip,flags,NULL);
}
// to undisplay ,
void FKCtrl::EndEditParams( IObjParam *ip, ULONG flags,Animatable *next )
{
	if (solver)
		solver->EndEditParams(ip,flags,NULL);
	if (FK)
		FK->EndEditParams(ip,flags,NULL);
}

//Reference Methods
RefTargetHandle FKCtrl::GetReference(int i)
{
	switch(i)
	{
	case LOCALPBLOCK_REF:
		return prefPblock;
		break;
	case LOCALCTRL_REF:
		return FK;
		break;
	case SOLVERPBLOCK_REF:
		return pblock;
		break;
	case SOLVER_REF:
		return solver;
		break;
	}
	return NULL;
}
void FKCtrl::SetReference(int i, RefTargetHandle rtarg)
{
	switch(i)
	{
	case LOCALPBLOCK_REF:
		prefPblock=(IParamBlock2*)rtarg;
		break;
	case LOCALCTRL_REF:
		FK=(Control*)rtarg;
		if (solver)
			solver->RefreshKeys();
		break;
	case SOLVERPBLOCK_REF:
		pblock=(IParamBlock2*)rtarg;
		break;
	case SOLVER_REF:
		solver=(IKFKSolver*) rtarg;
		break;
	}
}

#if IS_SUPMAX2015
RefResult FKCtrl::NotifyRefChanged(const Interval& changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message, BOOL propagate)
#else
RefResult FKCtrl::NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message)
#endif
{
	switch(message)
	{
	case REFMSG_CHANGE:
		{
			if (hTarget==pblock && pblock)
			{
				return REF_STOP;
			}
			else if (solver)
			{
				solver->NotifyChange();
				return REF_STOP;
			}
		}
		break;
	case REFMSG_KEY_SELECTION_CHANGED:
		{
			if ((hTarget==FK || hTarget==prefPblock) && solver && hTarget)
				solver->NotifyKeySelChange();
			return REF_STOP;
		}
		break;
	case REFMSG_CONTROLREF_CHANGE:
		{
			if (solver)
				solver->RefreshKeys();
		}
		break;
	}
	return REF_SUCCEED;
}

//Control Methods
void FKCtrl::Copy(Control *from)
{
	ReplaceReference(LOCALCTRL_REF,from);
}
RefTargetHandle FKCtrl::Clone( RemapDir &remap )
{
	FKCtrl *p=new FKCtrl();
	p->ReplaceReference(SOLVER_REF,remap.CloneRef(solver));
	p->ReplaceReference(SOLVERPBLOCK_REF,remap.CloneRef(pblock));
	p->ReplaceReference(LOCALCTRL_REF,remap.CloneRef(FK));
	p->ReplaceReference(LOCALPBLOCK_REF,remap.CloneRef(prefPblock));
	BaseClone(this, p, remap);
	return p;
}

void FKCtrl::GetValue(TimeValue t, void *val, Interval &valid, GetSetMethod method)
{
	//if the solver is not processing then return the value, otherwise return the local FK Value itself
	if (solver && solver->Solve(t))
	{
		*((Matrix3*)val)=value;
		valid &=ivalid;
	}
	else
	{
		if (FK)
			FK->GetValue(t,val,valid,method);
	}
}
void FKCtrl::SetValue(TimeValue t, void *val, int commit, GetSetMethod method)
{
	SetXFormPacket *setTM=((SetXFormPacket*)val);
	if (solver && FK)
	{
		if (setTM->command==XFORM_ROTATE)
		{
			INode *mainNode=solver->GetMainNode();
			INode *secNode=solver->GetSecNode();
			INode *targetNode=solver->GetTargetNode();
			BOOL matchScaleMult=FALSE,matchMainPref=FALSE,matchSecPref=FALSE,matchIKFK=FALSE,matchTargetSwivel=FALSE;

			if (solver->pblock)
			{
				solver->pblock->GetValue(pb_matchScaleMult,0,matchScaleMult,FOREVER);
				solver->pblock->GetValue(pb_matchMainPreferred,0,matchMainPref,FOREVER);
				solver->pblock->GetValue(pb_matchSecPreferred,0,matchSecPref,FOREVER);
				solver->pblock->GetValue(pb_matchIKFK,0,matchIKFK,FOREVER);
				solver->pblock->GetValue(pb_matchTargetSwivel,0,matchTargetSwivel,FOREVER);
			}
			if (mainNode && this==mainNode->GetTMController())//main node being transformed
			{
				solver->SetCanUpdate(FALSE);

				Point3 newTargetPos, prevLastPos;

				solver->Solve(t,FORCE_SOLVE);
				prevLastPos=solver->lastTM.GetTrans();
				/*if (matchScaleMult)
					solver->ScaleMultMatch(t);*/
				if (matchIKFK)
					solver->FKMatch(t,this);

				//commit value to local controller
				FK->SetValue(t,val,commit,method);

				solver->Solve(t,FORCE_SOLVE+FULL_FKMAIN);
				if (targetNode && matchTargetSwivel)
					newTargetPos=solver->TargetMatch1(t,prevLastPos); //target Match is made in 2 steps (to avoid double trans when target is linked to goal parent)
				if (matchIKFK)
					solver->IKMatch(t);
				if (matchTargetSwivel)
					if (targetNode)
						solver->TargetMatch2(t,newTargetPos);
					else
						solver->SwivelMatch(t);
				if (matchMainPref)
					solver->MainPrefMatch(t);

				solver->SetCanUpdate(TRUE);
				solver->NotifyChange();
			}
			else if (secNode && this==secNode->GetTMController())//second node being transformed
			{
				solver->SetCanUpdate(FALSE);

				Point3 newTargetPos,prevLastPos;

				solver->Solve(t,FORCE_SOLVE);
				prevLastPos=solver->lastTM.GetTrans();
				if (matchScaleMult)
					solver->ScaleMultMatch(t);
				if (matchIKFK)
					solver->FKMatch(t,this);

				//commit value to local controller
				FK->SetValue(t,val,commit,method);

				solver->Solve(t,FORCE_SOLVE+FULL_FKSEC);
				if (matchSecPref)
					solver->SecPrefMatch(t);
				if (targetNode && matchTargetSwivel)
					if (matchSecPref)
						newTargetPos=solver->TargetMatch1(t,prevLastPos);
				if (matchIKFK)
					solver->IKMatch(t);
				if (matchTargetSwivel)
					if (targetNode)
					{
						if (matchSecPref)
							solver->TargetMatch2(t,newTargetPos);
					}
					else
						solver->SwivelMatch(t);

				solver->SetCanUpdate(TRUE);
				solver->NotifyChange();
			} 
			else
				FK->SetValue(t,val,commit,method);
		}
		else if (setTM->command==XFORM_MOVE)
		{
			BOOL matchIKFK=FALSE,matchTargetSwivel=FALSE;
			int numSelectedIK,numSelectedFK,numSelectedTarget;

			if (solver->pblock)
			{
				solver->pblock->GetValue(pb_matchIKFK,0,matchIKFK,FOREVER);
				solver->pblock->GetValue(pb_matchTargetSwivel,0,matchTargetSwivel,FOREVER);
			}

			numSelectedIK=solver->NumSelectedIKGoal();
			numSelectedFK=solver->NumSelectedFK();
			numSelectedTarget=solver->NumSelectedIKTarget();

			if (numSelectedIK+numSelectedTarget)
			{
				solver->SetCanUpdate(FALSE);

				//Match IK to Current only if its the first one being transformed
				if (solver->setTMCount==0) 
				{
					solver->Solve(t,FORCE_SOLVE);
					if (numSelectedIK && matchIKFK)//match IK Goal only if the Goal or any goal parent is selected
						solver->IKMatch(t);
				}

				//commit value to local controller
				FK->SetValue(t,val,commit,method);

				//Match FK to IK only if it's the last one being transformed
				if (solver->setTMCount>=(numSelectedIK+numSelectedFK+numSelectedTarget-1))
				{
					BOOL matchMainPref=FALSE;
					if (solver->pblock)
						solver->pblock->GetValue(pb_matchMainPreferred,0,matchMainPref,FOREVER);		
					solver->Solve(t,FORCE_SOLVE+FULL_IKGOAL);
					if (matchIKFK)
						solver->FKMatch(t);
					if (matchMainPref)
						solver->MainPrefMatch(t);
					solver->setTMCount=0;
				}
				else
					solver->setTMCount++;

				solver->SetCanUpdate(TRUE);
				solver->NotifyChange();
			}
			else
				FK->SetValue(t,val,commit,method);//commit value to local controller
		}
		else
			FK->SetValue(t,val,commit,method);//commit value to local controller
	}
	else if (FK)
		FK->SetValue(t,val,commit,method);//commit value to local controller
}
void FKCtrl::CommitValue(TimeValue t)
{
	if (FK)
		FK->CommitValue(t);
}
void FKCtrl::RestoreValue(TimeValue t)
{
	if (FK)
		FK->RestoreValue(t);
}
BOOL FKCtrl::ChangeParents  (TimeValue  t,const Matrix3 &oldP, const Matrix3 &newP, const Matrix3 &tm)
{
	BOOL flag=FALSE;
	if (solver && FK)
	{
		INode *mainNode=solver->GetMainNode();
		if (mainNode && this==mainNode->GetTMController())
			flag=FK->ChangeParents(t,oldP,newP,tm);
		solver->NotifyChange();
		return flag;
	}
	else if (FK)
		return FK->ChangeParents(t,oldP,newP,tm);
	return FALSE;
}
void FKCtrl::Match()
{
	if (solver)
		solver->Match(GetCOREInterface()->GetTime());
}
void FKCtrl::SetFK()
{
	if (solver && solver->pblock)
	{
		solver->Match(GetCOREInterface()->GetTime());
		solver->pblock->SetValue(0,GetCOREInterface()->GetTime(),0.0f);
	}
}
void FKCtrl::SetIK()
{
	if (solver && solver->pblock)
	{
		solver->Match(GetCOREInterface()->GetTime());	
		solver->pblock->SetValue(0,GetCOREInterface()->GetTime(),1.0f);
	}
}
void FKCtrl::SetTargetNode(INode *theNode)
{
	if (solver)
	{
		if (!theNode || solver->isValidTarget(theNode)) 
		{
			ICustButton *iBut;
			solver->SetTargetNode(theNode);
			iBut = GetICustButton(GetDlgItem(solver->hwnd2,IDC_BUTTON_TARGET));
			ICustEdit *iEdit = GetICustEdit(GetDlgItem(solver->hwnd1,IDC_EDIT_IKFKSWIVEL));
			if (iBut && iEdit)
			{
				if (theNode)
					iBut->SetText(theNode->GetName());
				else
					iBut->SetText(_T("None"));
				iEdit->Enable(!theNode);
				ReleaseICustEdit(iEdit);
				ReleaseICustButton(iBut);
			}
		}
		else
		{
			throw RuntimeError (_T("invalid target"));
		}
	}
}
void FKCtrl::SetGoalParentNode(INode *theNode)
{
	if (solver)
	{
		if (!theNode || solver->isValidGoalParent(theNode)) 
		{
			ICustButton *iBut;
			solver->SetGoalParentNode(theNode);
			iBut = GetICustButton(GetDlgItem(solver->hwnd2,IDC_BUTTON_TARGET));
			if (iBut)
			{
				if (theNode)
					iBut->SetText(theNode->GetName());
				else
					iBut->SetText(_T("None"));
				ReleaseICustButton(iBut);
			}
		}
		else
		{
			throw RuntimeError (_T("invalid goal parent"));
		}
	}
}