#include "ikctrl.h"
#include "fkctrl.h"

static IKCtrlClassDesc IKCtrlDesc;
ClassDesc2* GetIKCtrlDesc() { return &IKCtrlDesc; }
static IKCtrlClassAccessor IKCtrlAccessor;

enum { 
	IKCtrl_params,
};


static ParamBlockDesc2 IKCtrl_param_blk ( IKCtrl_params, _T("params"),  0, &IKCtrlDesc, 
	P_AUTO_CONSTRUCT, LOCALPBLOCK_REF, 
	// params
	pb_matchMainPreferred,	_T("MatchMainPrefRotation"),	TYPE_BOOL,	P_NO_REF,	IDS_MATCHMAINPREFERRED,
		p_accessor,		&IKCtrlAccessor,
		end,
	pb_matchSecPreferred,	_T("MatchSecPrefRotation"),	TYPE_BOOL,	P_NO_REF,	IDS_MATCHSECPREFERRED,
		p_accessor,		&IKCtrlAccessor,
		end,
	pb_matchScaleMult,	_T("MatchScaleMult"),	TYPE_BOOL,	P_NO_REF,	IDS_MATCHSCALEMULT,
		p_accessor,		&IKCtrlAccessor,
		end,
	pb_parentSpace, 	_T("ParentSpace"),		TYPE_INT,		P_NO_REF,				IDS_PARENTSPACE, 
		p_accessor,		&IKCtrlAccessor,
		end,
	pb_prefTreshold,	_T("PrefTreshold"), 		TYPE_ANGLE, 	P_NO_REF, 	IDS_PREFTRESHOLD, 
		p_accessor,		&IKCtrlAccessor,
		end,
	pb_displayGoal,	_T("DisplayGoal"),	TYPE_INT,	P_NO_REF,	IDS_DISPLAYGOAL,
		p_accessor,		&IKCtrlAccessor,
		end,
	pb_displayTarget,	_T("DisplayTarget"),	TYPE_INT,	P_NO_REF,	IDS_DISPLAYTARGET,
		p_accessor,		&IKCtrlAccessor,
		end,
	pb_displayIKFK,	_T("DisplayIKFK"),	TYPE_BOOL,	P_NO_REF,	IDS_DISPLAYTARGET,
		p_accessor,		&IKCtrlAccessor,
		end,
	pb_showAllKeys,	_T("ShowAllNodesKeys"),	TYPE_BOOL,	P_NO_REF,	IDS_SHOWALLKEYS,
		p_accessor,		&IKCtrlAccessor,
		end,
	pb_matchIKFK,	_T("MatchIKFK"),	TYPE_BOOL,	P_NO_REF,	IDS_MATCHIKFK,
		p_accessor,		&IKCtrlAccessor,
		end,
	pb_matchTargetSwivel,	_T("MatchTargetSwivel"),	TYPE_BOOL,	P_NO_REF,	IDS_MATCHTARGETSWIVEL,
		p_accessor,		&IKCtrlAccessor,
		end,
	end
	);

//interface desc to publish functions
static FPInterfaceDesc IKCtrlDesc_mixininterface(IKFKSOLVER_INTERFACE, 
   _T("refs"), 0, &IKCtrlDesc, 0, 
   IKFKSolverInterface::fnMatch, _T("Match"), 0, TYPE_VOID, 0, 0, 
   IKFKSolverInterface::fnSetFK, _T("SetFK"), 0, TYPE_VOID, 0, 0,
   IKFKSolverInterface::fnSetIK, _T("SetIK"), 0, TYPE_VOID, 0, 0,
   IKFKSolverInterface::fnGetMainFKNode, _T("GetMainFKNode"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnGetSecFKNode, _T("GetSecFKNode"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnGetLastFKNode, _T("GetLastFKNode"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnGetGoal, _T("GetGoal"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnGetTarget, _T("GetTarget"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnGetGoalParent, _T("GetGoalParent"), 0, TYPE_INODE, 0, 0,
   IKFKSolverInterface::fnSetTarget, _T("SetTarget"), 0, TYPE_VOID, 0, 1, 
     _T("Target Node"), 0, TYPE_INODE, 
   IKFKSolverInterface::fnSetGoalParent, _T("SetGoalParent"), 0, TYPE_VOID, 0, 1, 
     _T("Goal Parent Node"), 0, TYPE_INODE,
   end 
); 

FPInterfaceDesc* IKCtrl::GetDesc() 
{ 
   return &IKCtrlDesc_mixininterface; 
}

void IKCtrlClassAccessor::Set (PB2Value &v, ReferenceMaker *owner, ParamID id, int tabIndex, TimeValue t)
{
	IKCtrl* theIKCtrl=((IKCtrl*)owner);
	if (theIKCtrl && theIKCtrl->solver && theIKCtrl->solver->pblock)
	{
		if (id==pb_prefTreshold)
			theIKCtrl->solver->pblock->SetValue(id,t,v.f);
		else
			theIKCtrl->solver->pblock->SetValue(id,t,v.i);
	}
}
void IKCtrlClassAccessor::Get (PB2Value &v, ReferenceMaker *owner, ParamID id, int tabIndex, TimeValue t, Interval &valid)
{
	IKCtrl* theIKCtrl=((IKCtrl*)owner);
	if (theIKCtrl && theIKCtrl->solver && theIKCtrl->solver->pblock)
	{
		if (id==pb_prefTreshold)
			theIKCtrl->solver->pblock->GetValue(id,t,v.f,valid);
		else
			theIKCtrl->solver->pblock->GetValue(id,t,v.i,valid);
	}
}

IKCtrl::IKCtrl(BOOL loading)
{
	IK=NULL;
	IKPblock=NULL;
	pblock=NULL;
	solver=NULL;
	value=Matrix3(1);
	ivalid=FOREVER;
	sendingMessage=FALSE;
	allKeysActive=FALSE;
	if (!loading)
		IKCtrlDesc.MakeAutoParamBlocks(this);
}
IKCtrl::IKCtrl(IKFKSolver *theSolver)
{
	IK=NULL;
	IKPblock=NULL;
	pblock=NULL;
	solver=NULL;
	value=Matrix3(1);
	ivalid=FOREVER;
	sendingMessage=FALSE;
	allKeysActive=FALSE;
	IKCtrlDesc.MakeAutoParamBlocks(this);
	ReplaceReference(LOCALCTRL_REF,NewDefaultMatrix3Controller());
	if (theSolver)
		ReplaceReference(SOLVERPBLOCK_REF,theSolver->pblock);
	ReplaceReference(SOLVER_REF,theSolver);
}
IKCtrl::~IKCtrl()
{
	DeleteAllRefs();
}
//Animatable Methods

Animatable* IKCtrl::SubAnim(int i)
{
	switch(i)
	{
	case LOCALPBLOCK_REF:
		return NULL;
		break;
	case LOCALCTRL_REF:
		return IK;
		break;
	case SOLVERPBLOCK_REF:
		return solver;
		break;
	}
	return NULL;
}
TSTR IKCtrl::SubAnimName(int i)
{
	switch(i)
	{
	case LOCALCTRL_REF:
		return GetString(IDS_IK);
		break;
	case SOLVERPBLOCK_REF:
		return GetString(IDS_PARAMS);
		break;
	}
	return _T("");
}
BOOL IKCtrl::AssignController(Animatable *control,int subAnim)
{
	if (subAnim==LOCALCTRL_REF)
	{
		ReplaceReference(subAnim,(Control*)control);
		return TRUE;
	}
	else
		return FALSE;
}

//to display controller params on the motion panel,
void IKCtrl::BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev )
{
	if (solver)
		solver->BeginEditParams(ip,flags,NULL);
	if (IK)
		IK->BeginEditParams(ip,flags,NULL);
}
// to undisplay , 
void IKCtrl::EndEditParams( IObjParam *ip, ULONG flags,Animatable *next )
{
	if (solver)
		solver->EndEditParams(ip,flags,NULL);
	if (IK)
		IK->EndEditParams(ip,flags,NULL);
}

//Reference Methods
RefTargetHandle IKCtrl::GetReference(int i)
{
	switch(i)
	{
	case LOCALPBLOCK_REF:
		return IKPblock;
		break;
	case LOCALCTRL_REF:
		return IK;
		break;
	case SOLVERPBLOCK_REF:
		return pblock;
		break;
	case SOLVER_REF:
		return solver;
		break;
	}
	return NULL;
}
void IKCtrl::SetReference(int i, RefTargetHandle rtarg)
{
	switch(i)
	{
	case LOCALPBLOCK_REF:
		IKPblock=(IParamBlock2*)rtarg;
		break;
	case LOCALCTRL_REF:
		IK=(Control*)rtarg;
		if (solver)
			solver->RefreshKeys();
		break;
	case SOLVERPBLOCK_REF:
		pblock=(IParamBlock2*)rtarg;
		break;
	case SOLVER_REF:
		solver=(IKFKSolver*) rtarg;
		break;
	}
}

#if IS_SUPMAX2015
RefResult IKCtrl::NotifyRefChanged(const Interval& changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message, BOOL propagate)
#else
RefResult IKCtrl::NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message)
#endif
{
	switch(message)
	{
	case REFMSG_CHANGE:
		{
			if (hTarget==pblock && pblock)
			{
				return REF_STOP;
			}
			else if (solver)
			{
				solver->NotifyChange();
				return REF_STOP;	
			}
		}
		break;
	case REFMSG_KEY_SELECTION_CHANGED:
		{
			if ((hTarget==IK || hTarget==IKPblock) && solver && hTarget)
				solver->NotifyKeySelChange();
			return REF_STOP;
		}
		break;
	case REFMSG_CONTROLREF_CHANGE:
		{
			if (solver)
				solver->RefreshKeys();
		}
		break;
	}
	return REF_SUCCEED;
}

//Control Methods
void IKCtrl::Copy(Control *from)
{
	ReplaceReference(LOCALCTRL_REF,from);
	NotifyDependents(FOREVER,0,REFMSG_CHANGE);
	NotifyDependents(FOREVER,0,REFMSG_SUBANIM_STRUCTURE_CHANGED);
}
RefTargetHandle IKCtrl::Clone( RemapDir &remap )
{
	IKCtrl *p=new IKCtrl();
	p->ReplaceReference(SOLVER_REF,remap.CloneRef(solver));
	p->ReplaceReference(SOLVERPBLOCK_REF,remap.CloneRef(pblock));
	p->ReplaceReference(LOCALCTRL_REF,remap.CloneRef(IK));
	p->ReplaceReference(LOCALPBLOCK_REF,remap.CloneRef(IKPblock));
	BaseClone(this, p, remap);
	return p;
}

void IKCtrl::GetValue(TimeValue t, void *val, Interval &valid, GetSetMethod method)
{
	//if the solver is not processing then return the value, otherwise return the local IK Value itself
	if (solver && solver->Solve(t))
	{
		*((Matrix3*)val)=value;
		valid &=ivalid;
	}
	else if (IK)
		IK->GetValue(t,val,valid,method);
}

void IKCtrl::SetValue(TimeValue t, void *val, int commit, GetSetMethod method)
{
	if (solver && IK)
	{
		SetXFormPacket setTM=*((SetXFormPacket*)val);
		if (setTM.command==XFORM_MOVE) //match only if the fknodes are not being translated
		{
			solver->SetCanUpdate(FALSE);

			BOOL matchIKFK=FALSE,matchTargetSwivel=FALSE;
			int numSelectedIK,numSelectedFK,numSelectedTarget;

			if (solver->pblock)
			{
				solver->pblock->GetValue(pb_matchIKFK,0,matchIKFK,FOREVER);
				solver->pblock->GetValue(pb_matchTargetSwivel,0,matchTargetSwivel,FOREVER);
			}

			numSelectedIK=solver->NumSelectedIKGoal();
			numSelectedFK=solver->NumSelectedFK();
			numSelectedTarget=solver->NumSelectedIKTarget();
			//Match IK to Current only if its the first one being transformed
			if (solver->setTMCount==0)
			{
				solver->Solve(t,FORCE_SOLVE);
				if (numSelectedIK && matchIKFK)//match IK Goal only if the Goal or any goal parent is selected
					solver->IKMatch(t);
			}

			//commit value to local controller
			IK->SetValue(t,val,commit,method);

			//Match FK to IK only if it's the last one being transformed
			if (solver->setTMCount>=(numSelectedIK+numSelectedFK+numSelectedTarget-1))
			{
				BOOL matchMainPref=FALSE;
				if (pblock)
					pblock->GetValue(pb_matchMainPreferred,0,matchMainPref,FOREVER);

				unsigned char theFlag=FORCE_SOLVE;
				if (numSelectedTarget && !numSelectedIK)
					theFlag+=FULL_IKTARGET;
				else
					theFlag+=FULL_IKGOAL;
				solver->Solve(t,theFlag);
				if (matchIKFK)
					solver->FKMatch(t);
				if (matchMainPref)
					solver->MainPrefMatch(t);
				solver->setTMCount=0;
			}
			else
				solver->setTMCount++;

			solver->SetCanUpdate(TRUE);
			solver->NotifyChange();
		}
		else
			IK->SetValue(t,val,commit,method);//commit value to local controller
	}
	else if (IK)
		IK->SetValue(t,val,commit,method);//commit value to local controller
}
void IKCtrl::CommitValue(TimeValue t)
{
	if (IK)
		IK->CommitValue(t);
}
void IKCtrl::RestoreValue(TimeValue t)
{
	if (IK)
		IK->RestoreValue(t);
}

//Display
//this function display lines representing the solver, there are two type of displays:
// Goal Lines: those lines conect the three positions of the fk nodes.
// Target Line: this line conect the position of the target node with the sec node.
// the display is active depending on the options selected by the user (never, selected, always) of each
// type of display
int IKCtrl::Display (TimeValue t,INode* inode,ViewExp* vpt,int flags)
{
	BOOL displayflag=FALSE;
	if (solver)
	{
		if(solver->DisplayIKFK(t,inode,vpt,flags))
			return 1;
		INode *goalNode=solver->GetGoalNode();
		if (goalNode && inode==goalNode && solver->CanUpdate() && solver->pblock)
		{			
			int displayGoal,displayTarget;
			solver->pblock->GetValue(pb_displayGoal,0,displayGoal,FOREVER);
			solver->pblock->GetValue(pb_displayTarget,0,displayTarget,FOREVER);

			if (displayTarget)
			{
				INode* targetNode=solver->GetTargetNode();

				//check if the target line should be displayed
				if (targetNode && (displayTarget==2   || (displayTarget==1 && targetNode->Selected())))
				{
					Point3 ikfkcolor;
					float IKFKBlend;
					Point3 points[2];

					solver->pblock->GetValue(pb_IKFKBlend,t,IKFKBlend,FOREVER);
					ikfkcolor=(IKFKBlend*IK_COLOR)+((1.0f-IKFKBlend)*FK_COLOR);

					//collect the position of the target and the sec node
					points[0]=solver->secTM.GetTrans();
					points[1]=solver->targetTM.GetTrans();

					//draw the line
					GraphicsWindow *gw = vpt->getGW();
					gw->setTransform(Matrix3(1));
					gw->setColor(LINE_COLOR, ikfkcolor);
					gw->polyline( 2, points, NULL, NULL, FALSE, NULL );
					displayflag=TRUE;
				}
			}
			if (displayGoal)
			{
				
				BOOL ikselected=FALSE;

				//find out if any goalparent or the goal is selected
				if (displayGoal==1)
				{
					if (goalNode->Selected())
						ikselected=TRUE;
					else
					{
						INode *parentNode;
						for (int i=0;i<solver->GoalParentCount();i++)
						{
							parentNode=solver->GetGoalParentNode(i);
							if (parentNode && parentNode->Selected())
							{
								ikselected=TRUE;
								break;
							}
						}
					}
				}
				//check if the goal line should be displayed
				if (ikselected || displayGoal==2)
				{
					Point3 ikfkcolor;
					float IKFKBlend;
					Point3 points[3];

					solver->pblock->GetValue(pb_IKFKBlend,t,IKFKBlend,FOREVER);
					ikfkcolor=(IKFKBlend*IK_COLOR)+((1.0f-IKFKBlend)*FK_COLOR);

					//collect the positions of the fk nodes (main,sec,last)
					points[0]=solver->mainTM.GetTrans();
					points[1]=solver->secTM.GetTrans();
					points[2]=solver->lastTM.GetTrans();

					//draw the lines
					GraphicsWindow *gw = vpt->getGW();
					gw->setTransform(Matrix3(1));
					gw->setColor(LINE_COLOR, ikfkcolor);
					gw->polyline( 3, points, NULL, NULL, TRUE, NULL );
					displayflag=TRUE;
				}
			}
		}
	}
	return displayflag;
}
void IKCtrl::GetWorldBoundBox(TimeValue t,INode *inode,ViewExp *vpt,Box3 &box)
{
	if (solver)
	{
		box+=solver->mainTM.GetTrans();
		box+=solver->secTM.GetTrans();
		box+=solver->lastTM.GetTrans();
		if (solver->GetTargetNode())
			box+=solver->targetTM.GetTrans();
	}
}

BOOL IKCtrl::ChangeParents  (TimeValue  t,const Matrix3 &oldP, const Matrix3 &newP, const Matrix3 &tm)
{
	if (solver && IK)
	{
		BOOL flag=FALSE;
		solver->CheckHierarchy();
		flag=IK->ChangeParents(t,oldP,newP,tm);
		solver->NotifyChange();
		return flag;
	}
	else if (IK)
		return IK->ChangeParents(t,oldP,newP,tm);
	return FALSE;
}

void IKCtrl::Match()
{
	if (solver)
		solver->Match(GetCOREInterface()->GetTime());
}
void IKCtrl::SetFK()
{
	if (solver && solver->pblock)
	{
		solver->Match(GetCOREInterface()->GetTime());
		solver->pblock->SetValue(0,GetCOREInterface()->GetTime(),0.0f);
	}
}
void IKCtrl::SetIK()
{
	if (solver && solver->pblock)
	{
		solver->Match(GetCOREInterface()->GetTime());
		solver->pblock->SetValue(0,GetCOREInterface()->GetTime(),1.0f);
	}
}
void IKCtrl::SetTargetNode(INode *theNode)
{
	if (solver)
	{
		if (!theNode || solver->isValidTarget(theNode)) 
		{
			ICustButton *iBut;
			solver->SetTargetNode(theNode);
			iBut = GetICustButton(GetDlgItem(solver->hwnd2,IDC_BUTTON_TARGET));
			ICustEdit *iEdit = GetICustEdit(GetDlgItem(solver->hwnd1,IDC_EDIT_IKFKSWIVEL));
			if (iBut && iEdit)
			{
				if (theNode)
					iBut->SetText(theNode->GetName());
				else
					iBut->SetText(_T("None"));
				iEdit->Enable(!theNode);
				ReleaseICustEdit(iEdit);
				ReleaseICustButton(iBut);
			}
		}
		else
		{
			throw RuntimeError (_T("invalid target"));
		}
	}
}
void IKCtrl::SetGoalParentNode(INode *theNode)
{
	if (solver)
	{
		if (!theNode || solver->isValidGoalParent(theNode)) 
		{
			ICustButton *iBut;
			solver->SetGoalParentNode(theNode);
			iBut = GetICustButton(GetDlgItem(solver->hwnd2,IDC_BUTTON_TARGET));
			if (iBut)
			{
				if (theNode)
					iBut->SetText(theNode->GetName());
				else
					iBut->SetText(_T("None"));
				ReleaseICustButton(iBut);
			}
		}
		else
		{
			throw RuntimeError (_T("invalid goal parent"));
		}
	}
}

